SystemOrganization addCategory: #'Pier-Google'!

PRStructure subclass: #PRGoogleGadget
	instanceVariableNames: 'url xml settings description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Google'!

!PRGoogleGadget commentStamp: 'lr 1/5/2009 20:32' prior: 0!
Google Gadgets are simple HTML and JavaScript applications that can be embedded in webpages and other apps. Choose from thousands of Google Gadgets for your Pier installation from the Google Gadget Directory at http://www.google.com/ig/directory?synd=open.!

!PRGoogleGadget class methodsFor: 'accessing-settings' stamp: 'lr 1/6/2009 16:21'!
descriptionBorder
	^ MAStringDescription new
		default: '#ffffff|3px,1px solid #999999';
		propertyAt: #urlparam put: 'border';
		group: 'Widget Preferences';
		accessor: #border;
		priority: 2020;
		beSetting;
		yourself! !

!PRGoogleGadget class methodsFor: 'accessing-settings' stamp: 'lr 1/6/2009 16:21'!
descriptionHeight
	^ MANumberDescription new
		propertyAt: #urlparam put: 'h';
		group: 'Widget Preferences';
		accessor: #height;
		priority: 2010;
		default: 75;
		beSetting;
		yourself! !

!PRGoogleGadget class methodsFor: 'accessing-editing' stamp: 'lr 1/5/2009 20:47'!
descriptionUrl
	^ MAStringDescription new
		label: 'Source URL';
		accessor: #url;
		priority: 200;
		beRequired;
		beEditable;
		yourself! !

!PRGoogleGadget class methodsFor: 'accessing-editing' stamp: 'lr 1/5/2009 20:47'!
descriptionUrlComment
	^ MAMemoDescription new
		accessor: #urlComment;
		priority: 210;
		beReadonly;
		beEditable;
		label: '';
		yourself! !

!PRGoogleGadget class methodsFor: 'accessing-settings' stamp: 'lr 1/6/2009 16:21'!
descriptionWidth
	^ MANumberDescription new
		propertyAt: #urlparam put: 'w';
		group: 'Widget Preferences';
		accessor: #width;
		priority: 2000;
		default: 320;
		beSetting;
		yourself! !

!PRGoogleGadget class methodsFor: 'testing' stamp: 'lr 1/5/2009 20:39'!
isAbstract
	^ false! !

!PRGoogleGadget methodsFor: 'visiting' stamp: 'lr 1/5/2009 20:39'!
accept: aVisitor
	aVisitor visitGoogleGadget: self! !

!PRGoogleGadget methodsFor: 'preferences' stamp: 'lr 1/6/2009 15:57'!
convertBoolPreference: anXmlElement
	^ MABooleanDescription new! !

!PRGoogleGadget methodsFor: 'preferences' stamp: 'lr 1/6/2009 16:08'!
convertEnumPreference: anXmlElement
	| options |
	options := OrderedCollection new.
	anXmlElement tagsNamed: #'EnumValue' 	childrenDoAndRecurse: [ :each |
		each attributes at: 'value' ifPresent: [ :value |
			options addLast: value -> (each attributes
				at: 'display_value' ifAbsent: [ value ]) ] ].
	^ MASingleOptionDescription new
		optionsAndLabels: options;
		yourself! !

!PRGoogleGadget methodsFor: 'preferences' stamp: 'lr 1/6/2009 16:19'!
convertGenericPreference: anXmlElement
	| preference datatype |
	preference := nil.
	datatype := anXmlElement attributes at: 'datatype' ifAbsent: [ 'string' ].
	#( 'string' convertStringPreference: 'bool' convertBoolPreference: 'enum' convertEnumPreference: 'list' convertListPreference: ) pairsDo: [ :type :selector |
		(preference isNil and: [ datatype = type ])
			ifTrue: [ preference := self perform: selector with: anXmlElement ] ].
	preference isNil ifTrue: [ ^ nil ].
	preference beSetting.
	preference group: 'User Preferences'.
	preference propertyAt: #xml put: anXmlElement.
	preference propertyAt: #urlparam put: (anXmlElement attributes 
		at: 'urlparam' ifAbsent: [ anXmlElement attributes 
		at: 'name' ifAbsent: [ ^ nil ] ]).
	preference accessor: (anXmlElement attributes 
		at: 'name' ifAbsent: [ ^ nil ]) asSymbol.
	anXmlElement attributes at: 'display_name' ifPresent: [ :value |
		preference label: value ].
	anXmlElement attributes at: 'required' ifPresent: [ :value | 
		value asLowercase = 'true'
			ifTrue: [ preference beRequired ] ].
	anXmlElement attributes at: 'default_value' ifPresent: [ :value |
		preference default: (preference fromString: value) ].
	^ self description add: preference! !

!PRGoogleGadget methodsFor: 'preferences' stamp: 'lr 1/6/2009 16:34'!
convertListPreference: anXmlElement
	^ nil! !

!PRGoogleGadget methodsFor: 'preferences' stamp: 'lr 1/6/2009 15:54'!
convertStringPreference: anXmlElement
	^ MAStringDescription new! !

!PRGoogleGadget methodsFor: 'accessing-dynamic' stamp: 'lr 1/6/2009 15:30'!
description
	^ description ifNil: [ description := super description ]! !

!PRGoogleGadget methodsFor: 'accessing-dynamic' stamp: 'lr 1/6/2009 16:32'!
gadgetUrl
	| gadgetUrl |
	gadgetUrl := WAUrl new.
	gadgetUrl hostname: 'www.gmodules.com'; path: #('ig' 'ifr').
	self description do: [ :desc |
		desc propertyAt: 'urlparam' ifPresent: [ :param |
			gadgetUrl addParameter: param value: (desc toString: (self readUsing: desc)) ] ].
	gadgetUrl addParameter: 'url' value: self url; addParameter: 'title' value: self title.
	gadgetUrl addParameter: 'synd' value: 'open'; addParameter: 'output' value: 'js'.
	^ gadgetUrl! !

!PRGoogleGadget methodsFor: 'private' stamp: 'lr 1/6/2009 16:17'!
readUsing: aDescription
	^ self settings
		at: (aDescription
			propertyAt: #urlparam
			ifAbsent: [ ^ super readUsing: aDescription ])
		ifAbsent: [ aDescription default ]! !

!PRGoogleGadget methodsFor: 'actions' stamp: 'lr 1/6/2009 16:09'!
refresh
	| response |
	xml := description := nil.
	description := MAContainer withAll: self description.
	response := [ HTTPSocket httpGet: self url ]
		ifError: [ :err | ^ self ].
	response isString 
		ifTrue: [ ^ self ].
	xml := [ XMLDOMParser parseDocumentFrom: response ]
		ifError: [ :err | ^ self ].
	xml 
		tagsNamed: #'UserPref'
		childrenDoAndRecurse: [ :each | self convertGenericPreference: each ]! !

!PRGoogleGadget methodsFor: 'accessing-dynamic' stamp: 'lr 1/6/2009 15:18'!
settings
	^ settings ifNil: [ settings := Dictionary new ]! !

!PRGoogleGadget methodsFor: 'accessing' stamp: 'lr 1/5/2009 20:35'!
url
	^ url! !

!PRGoogleGadget methodsFor: 'accessing' stamp: 'lr 1/6/2009 15:18'!
url: aString
	url := aString.
	self refresh
	


! !

!PRGoogleGadget methodsFor: 'accessing-dynamic' stamp: 'lr 1/5/2009 20:48'!
urlComment
	^ 'Choose from thousands of Google Gadgets for your Pier installation from the Google Gadget Directory at "http://www.google.com/ig/directory?synd=open". Select the Gadget you like and copy and paste the URL of the link "View Source" into the above input field.'! !

!PRGoogleGadget methodsFor: 'private' stamp: 'lr 1/6/2009 16:17'!
write: anObject using: aDescription
	^ self settings
		at: (aDescription
			propertyAt: #urlparam
			ifAbsent: [ ^ super write: anObject using: aDescription ])
		put: anObject! !

!PRViewRenderer methodsFor: '*pier-google-visiting' stamp: 'lr 1/5/2009 21:15'!
visitGoogleGadget: aStructure
	html script url: aStructure gadgetUrl! !

!PRVisitor methodsFor: '*pier-google-visiting' stamp: 'lr 1/5/2009 20:47'!
visitGoogleGadget: aStructure
	self visitStructure: aStructure! !

PRWidget subclass: #PRGoogleAnalyticsWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Google'!

!PRGoogleAnalyticsWidget class methodsFor: 'accessing-description' stamp: 'lr 4/10/2008 14:17'!
descriptionGoogleUACCT
	^ MAStringDescription new
		comment: 'The string Google Analytics provided you with (e.g. UA-XXXXXXX-Y)';
		accessor: #uacct;
		label: 'uacct';
		priority: 200;
		beSetting;
		yourself! !

!PRGoogleAnalyticsWidget class methodsFor: 'testing' stamp: 'lr 11/14/2007 19:49'!
isAbstract
	^ false! !

!PRGoogleAnalyticsWidget class methodsFor: 'accessing' stamp: 'tg 11/14/2007 13:01'!
label
	^ 'Google Analytics'! !

!PRGoogleAnalyticsWidget methodsFor: 'rendering' stamp: 'tg 12/20/2007 13:46'!
renderContentOn: html
	self uacct isEmptyOrNil ifTrue: [ ^ self ].
	html script: 'var gaJsHost = (("https:" == document.location.protocol) ? "https://ssl." : "http://www.");
document.write(unescape("%3Cscript src=''" + gaJsHost + "google-analytics.com/ga.js'' type=''text/javascript''%3E%3C/script%3E"));'.
	html script: 'var pageTracker = _gat._getTracker(', self uacct printString, ');
pageTracker._initData();
pageTracker._trackPageview();'! !

!PRGoogleAnalyticsWidget methodsFor: 'accessing' stamp: 'tg 11/14/2007 13:12'!
uacct
	^ self read: #descriptionGoogleUACCT! !

PRWidget subclass: #PRWebmasterToolsWidget
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Google'!

!PRWebmasterToolsWidget commentStamp: 'pmm 3/24/2008 11:55' prior: 0!
A PRWebmasterToolsWidget is a widget that helps you to activate your site at Google Webmaster Tools.

https://www.google.com/webmasters/tools/docs/en/about.html

For maximum effect use it together with the Sitemap plugin.
!

!PRWebmasterToolsWidget class methodsFor: 'accessing-description' stamp: 'pmm 3/24/2008 12:09'!
descriptionVerificationKey
	^ MAStringDescription new
		comment: 'The Google Webmaster Tools Verification Key';
		selectorAccessor: #verificationKey;
		label: 'Verification Key';
		priority: 300;
		beSetting;
		yourself! !

!PRWebmasterToolsWidget class methodsFor: 'testing' stamp: 'pmm 3/24/2008 11:58'!
isAbstract
	^ false! !

!PRWebmasterToolsWidget class methodsFor: 'accessing' stamp: 'pmm 3/24/2008 12:00'!
label
	^ 'Google Webmaster Tools'! !

!PRWebmasterToolsWidget methodsFor: 'updating' stamp: 'pmm 3/24/2008 12:06'!
updateRoot: html
	super updateRoot: html.
	self verificationKey isEmptyOrNil ifTrue: [ ^self ].

	html meta
		name: 'verify-v1';
		content: self verificationKey! !

!PRWebmasterToolsWidget methodsFor: 'accessing' stamp: 'pmm 3/24/2008 12:09'!
verificationKey
	^ self read: #descriptionVerificationKey! !
